using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace NETSploit
{
    using System;
    using System.IO;

    internal class CodeChanger
    //TODO: handle PRE injection (now just POST is possible)
    {
        string assemblyName;
        string decompiledAssemblyName;

        public CodeChanger(string AssemblyName)
        {
            this.assemblyName = AssemblyName;
            decompiledAssemblyName = assemblyName + Configuration.decompileExtension;
        }

        public void Decompile()
        {
            FileUtilities.Decompile(assemblyName);
        }

        public void Recompile()
        {
            FileUtilities.Recompile(assemblyName);
        }
        
        private void HandleCodeBeforeInjection(StreamReader file, string searchMethodName, int maxStackSize, StreamWriter fileout)
        {
            string str = null;
            try
            {
                //read until we reach the method name
                while (((str = file.ReadLine()) != null) && !str.Contains(searchMethodName))
                {
                    //now we are at the beginning of the function
                    //write the method line
                    fileout.WriteLine(str);
                }
                fileout.WriteLine(str);
                //Continue to read until we reach the ".maxstack" line
                while (((str = file.ReadLine()) != null) && !str.Contains(".maxstack"))
                {
                    fileout.WriteLine(str);
                }
                //now we are at the ".maxstack" line
                int index = str.IndexOf(".maxstack");
                int num2 = int.Parse(str.Substring(index + ".maxstack".Length));
                //assuming worst case
                str = str.Replace(num2.ToString(), (num2 + maxStackSize).ToString());
                fileout.WriteLine(str);
            }
            catch (Exception exception)
            {
                Console.WriteLine("Exception: " + exception.Message);
            }
        }

        private void HandleCodeAfterInjection(StreamReader file, StreamWriter fileout)
        {
            string str = null;
            try
            {
                //Continue to read until end of file
                while ((str = file.ReadLine()) != null)
                {
                    fileout.WriteLine(str);
                }
                //now we are at the end of the file
            }
            catch (Exception exception)
            {
                Console.WriteLine("Exception: " + exception.Message);
            }
        }
        
        public void InjectExternalRef(PayloadExternalRef payloadExternalRef)
        {
            string tempFileName = decompiledAssemblyName + Configuration.tempExtension;
            StreamReader reader = new StreamReader(Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
            StreamReader reader2 = new StreamReader(Configuration.RefsDir + "\\" + payloadExternalRef.InjectedRefFile);
            StreamWriter writer = new StreamWriter(Configuration.DecompiledDir + "\\" + tempFileName);
            string str2 = null;
            string str3 = ".assembly";
            try
            {
                //Read the first line of text
                //Continue to read until we reach the method name
                string str4;
                while (((str2 = reader.ReadLine()) != null) && !str2.Contains(str3))
                {
                    writer.WriteLine(str2);
                }
                //now we are at the first external ref
                //write the ref file
                while ((str4 = reader2.ReadLine()) != null)
                {
                    writer.WriteLine(str4);
                }
                //write the first line of external (from before)
                writer.WriteLine(str2);
                //Continue to read until we reach the EOF
                while ((str2 = reader.ReadLine()) != null)
                {
                    writer.WriteLine(str2);
                }
            }
            catch (Exception exception)
            {
                Console.WriteLine("Exception: " + exception.Message);
            }
            reader.Close();
            reader2.Close();
            writer.Close();
            File.Delete(Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
            File.Move(Configuration.DecompiledDir + "\\" + tempFileName, Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
        }

        public void InjectFunction(PayloadFunction payloadFunction)
        {
            string tempFileName = decompiledAssemblyName + Configuration.tempExtension;
            StreamReader reader = new StreamReader(Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
            StreamReader reader2 = new StreamReader(Configuration.FunctionsDir + "\\" + payloadFunction.FunctionCodeFile);
            StreamWriter writer = new StreamWriter(Configuration.DecompiledDir + "\\" + tempFileName);
            string str2 = null;
            string injectionLocation = payloadFunction.InjectionLocation;
            try
            {
                //read until we reach the Injection Location
                string str4;
                while (((str2 = reader.ReadLine()) != null) && !str2.Contains(injectionLocation))
                {
                    writer.WriteLine(str2);
                }
                if (payloadFunction.BeforeLocation)
                {
                    //write the function
                    while ((str4 = reader2.ReadLine()) != null)
                    {
                        //Read the next line
                        writer.WriteLine(str4);
                    }
                    //write the line (from before)
                    writer.WriteLine(str2);
                }
                else
                {
                    //write the line (from before)
                    writer.WriteLine(str2);
                    //write the function
                    while ((str4 = reader2.ReadLine()) != null)
                    {
                        writer.WriteLine(str4);
                    }
                }
                while ((str2 = reader.ReadLine()) != null)
                //Continue to read until we reach the EOF
                {
                    writer.WriteLine(str2);
                }
            }
            catch (Exception exception)
            {
                Console.WriteLine("Exception: " + exception.Message);
            }
            reader.Close();
            reader2.Close();
            writer.Close();
            File.Delete(Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
            File.Move(Configuration.DecompiledDir + "\\" + tempFileName, Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
        }

        public void InjectPayloadCode(PayloadInjectedCode payloadInjectedCode)
        {
            try
            {
                //Pass the file path and file name to the StreamReader constructor
                string tempFileName = decompiledAssemblyName + Configuration.tempExtension;
                StreamReader file = new StreamReader(Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
                StreamReader reader2 = new StreamReader(Configuration.PayloadsDir + "\\" + payloadInjectedCode.InjectedCodeFile);
                StreamWriter fileout = new StreamWriter(Configuration.DecompiledDir + "\\" + tempFileName);
                this.HandleCodeBeforeInjection(file, payloadInjectedCode.InjectionLocation, payloadInjectedCode.StackSize, fileout);
                this.MergeCodePost(file, reader2, fileout);
                this.HandleCodeAfterInjection(file, fileout);
                file.Close();
                reader2.Close();
                fileout.Close();
                File.Delete(Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
                File.Move(Configuration.DecompiledDir + "\\" + tempFileName, Configuration.DecompiledDir + "\\" + decompiledAssemblyName);
            }
            catch (Exception exception)
            {
                Console.WriteLine("Exception: " + exception.Message);
            }
        }

        private void MergeCodePost(StreamReader file1, StreamReader file2, StreamWriter fileout)
        {
            string line = null;
            try
            {
                //Read the first line of text
                //              line = sr.ReadLine();

                //Continue to read until you reach end of the first file

                string str2 = "";
                while ((line = file1.ReadLine()) != null)
                {
                    //Read the next line

                    if (CodeUtilities.isRetLine(line))
                    {
                        str2 = file1.ReadLine();
                        if (CodeUtilities.isEndLine(str2))
                        {
                            break;
                        }
                        fileout.WriteLine(line);
                        fileout.WriteLine(str2);
                    }
                    else
                    {
                        fileout.WriteLine(line);
                    }
                }
                //now we have ret
                //no need for this ret line, it will be replaced
                //write the method line, for later saving

                int distance = CodeUtilities.toInt(CodeUtilities.ParseLineNumber(CodeUtilities.ExtractLineNumber(line)));
                //Continue to read until you reach end of the second file
                while ((line = file2.ReadLine()) != null)
                {
                    //Read the next line
                    fileout.WriteLine(CodeUtilities.ReplaceLineNumberInCode(line, distance));
                }
                //if read } before, write it
                fileout.WriteLine(str2);
            }
            catch (Exception exception)
            {
                Console.WriteLine("Exception: " + exception.Message);
            }
        }
        private void MergeCodePre(StreamReader file1, StreamReader file2, StreamWriter fileout)
        {
            //TODO
        }  
    }
}

