using System;
using System.Collections.Generic;
using System.Text;

namespace NETSploit
{
    using System;
    using System.Diagnostics;
    using System.IO;

    internal static class FileUtilities
    {
        public static void Decompile(string dllName)
        {
            Process process = new Process();
            process.StartInfo.FileName = Configuration.ildasmLocation;
            process.StartInfo.CreateNoWindow = true;
            process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            process.StartInfo.Arguments = Configuration.DecompileOptions + " " + Configuration.InputDir + "\\" + dllName + " /OUT=" + Configuration.DecompiledDir + "\\" + dllName + Configuration.decompileExtension;
            process.Start();
            process.WaitForExit();
            if (process.ExitCode != 0)
                throw new Exception("Error decompiling " + dllName);
        }

        public static void Recompile(string dllName)
        {
            Process process = new Process();
            process.StartInfo.FileName = Configuration.ilasmLocation;
            process.StartInfo.CreateNoWindow = true;
            process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            process.StartInfo.Arguments = Configuration.CompileOptions + " /OUTPUT=" + Configuration.OutputDir + "\\" + dllName + " " + Configuration.DecompiledDir + "\\" + dllName + Configuration.decompileExtension;
            process.Start();
            process.WaitForExit();
            if (process.ExitCode != 0)
                throw new Exception("Error recompiling " + dllName);
        }

        public static void CopyFromGAC(string dllName, string dllFullPath)
        {
            File.Copy(dllFullPath, Configuration.InputDir + "\\" + dllName, true);
        }

        public static bool IsFileExists(string dllFullPath)
        {
            return File.Exists(dllFullPath);
        }

        public static void DeleteDirContent(string directory)
        {
            string[] files = Directory.GetFiles(directory);
            foreach (string s in files)
            {
                File.Delete(s);
            }
            string[] dirs = Directory.GetDirectories(directory);
            foreach (string d in dirs)
            {
                Directory.Delete(d, true);
            }
        }

        public static void GenerateDeployer(string dllName, string dllLocation, string nativeImageLocation)
        {
            //generate deployer
           // StreamWriter writer = new StreamWriter(Configuration.OutputDir + "\\" + Configuration.deployFileName);
            StreamWriter writer = new StreamWriter(Configuration.deployFileName);
            writer.WriteLine("@echo off");
            writer.WriteLine("echo .NET-Sploit Auto-Generated batch file for deploying modified assemblies");
            writer.WriteLine("echo.");
            writer.WriteLine("echo Deploying " + dllName + " to " + dllLocation);
            writer.WriteLine("echo.");
            writer.WriteLine("copy /y " +Configuration.OutputDir + "\\" + dllName + " " + dllLocation + "\\" + dllName);
            writer.WriteLine("echo Disabling NGEN for " + dllName);
            writer.WriteLine("echo.");
            writer.WriteLine(Configuration.ngenLocation + " uninstall " + dllName);
            writer.WriteLine("echo Deleting native image from " + nativeImageLocation);
            writer.WriteLine("echo.");
            writer.WriteLine("rd /s /q " + nativeImageLocation);
            writer.Close();

            //generate undeployer
            //writer = new StreamWriter(Configuration.OutputDir + "\\" + Configuration.undeployFileName);
            writer = new StreamWriter(Configuration.undeployFileName);
            writer.WriteLine("@echo off");
            writer.WriteLine("echo .NET-Sploit Auto-Generated batch file for undeploying (restoring) modified assemblies");
            writer.WriteLine("echo.");
            writer.WriteLine("echo Undeploying " + dllName + " from " + dllLocation);
            writer.WriteLine("echo.");
            writer.WriteLine("copy /y " + Configuration.InputDir + "\\" + dllName + " " + dllLocation + "\\" + dllName);
            writer.Close();
        }
    }
}

